#INCLUDE "protheus.ch"
#INCLUDE "topconn.ch"

/*/
+--+
| Funcao    | RMPED01                                                       |
+--+--+--+--+
| Autor     | Marco Aurelio Molina                      | Data | 25/06/2013 |
+--+--+--+--+
| Descricao | Integracao do sistema Protheus com o sistema de pedido        | 
|           |eletronico ENTIRE.                                             |
+--+--+
| Uso       | Especifico RM (Peniel)                                        |
+--+
+--+
| Atualizaes Sofridas Desde a Construo Inicial                          |
+--+
| Programador | Data       | Motivo da Alteracao                            |
+--+--+--+
|             |            |	                                            |
+--+--+--+ /*/
#DEFINE PORT_FTP 21    
#DEFINE PATHEXP "\Entire\Envio\"

****************************
User Function RMPED01(lJOB)
****************************
Private cCabXML := '<?xml version="1.0" standalone="yes"?>'
lJOB := ( lJOB != Nil )        
                     
If lJOB
	
	WFPREPENV("01","01","RMPED01")
	
	CONOUT("Atualiza FTP Entire...")

	//-----------------------------------------------//
	//Atualiza apenas o arquivo de saldo em estoque  //
	//-----------------------------------------------//
	PED01EST(lJOB)	 
	
Else

	MsgRun("AGUARDE, Gerando XML de Clientes...",, { || PED01EXP(lJOB) } )

	MsgRun("AGUARDE, Gerando XML de Estoques...",, { || PED01EST(lJOB) } )

	MsgInfo("Operao Finalizada!")                            

EndIf

Return()


*****************************
Static Function PED01EXP(lJOB)
*****************************
Local c_arquivo := PATHEXP + "RM_Cliente_" + dtos(ddatabase) + strtran(time(),":","") + ".xml"
Local n_outfile := Fcreate(c_arquivo,0)
Local cString   := cCabXml
Local nCont     := 0
Local cQuery          

cQuery := "SELECT A1_COD,A1_LOJA,A1_CGC,A1_COD_MUN,A1_NOME,A1_NREDUZ,A1_DDD,A1_TEL,A1_FAX,A1_EMAIL,A1_GRPVEN,A1_EST,A1_CEP,A1_MUN,A1_END,A1_PSICOTR,A1_RMLISAN"
cQuery += " FROM " + RetSQLName("SA1")
cQuery += " WHERE D_E_L_E_T_ <> '*' AND A1_MSBLQL <> '1' AND LEFT(A1_NOME,2) <> 'ZZ' AND A1_ATIVO <> 'N' AND A1_MENSAGE <> '203' "
cQuery += " ORDER BY A1_COD,A1_LOJA"

TcQuery cQuery New Alias "TRB"

cString += '<clientes>'
dbSelectArea("TRB")
dbGoTop()
While !Eof()         
	
	cString += '<cliente>'
	cString += PedTag('cnpjcpf',TRB->A1_CGC)
	cString += PedTag('setorcod',TRB->A1_COD_MUN)
	cString += PedTag('razaosocial',Alltrim(TRB->A1_NOME))
	cString += PedTag('nomefantasia',Alltrim(TRB->A1_NREDUZ))
	cString += PedTag('telefone_1',Alltrim(TRB->A1_DDD) + " " + Alltrim(TRB->A1_TEL))
	cString += PedTag('fax',Alltrim(TRB->A1_DDD) + " " + Alltrim(TRB->A1_FAX))	
	cString += PedTag('email',Alltrim(TRB->A1_EMAIL))	
	cString += '<tipocliente>'
	cString += PedTag('tipoclientecod',If(!Empty(TRB->A1_GRPVEN),TRB->A1_GRPVEN,"FARMA"))
	cString += PedTag('tipoclienteabrev',If(!Empty(TRB->A1_GRPVEN),"RE","FA"))
	cString += PedTag('tipoclientedsc',If(!Empty(TRB->A1_GRPVEN),Alltrim(Posicione("ACY",1,xFilial("ACY") + TRB->A1_GRPVEN,"ACY_DESCRI")),"FARMACIA"))	
	cString += '</tipocliente>'                                                  
	cString += '<endereco>'	 
	cString += PedTag('cep',TRB->A1_CEP)
	cString += PedTag('uf',TRB->A1_EST)	
	cString += PedTag('cidade',TRB->A1_MUN)
	cString += PedTag('logradouro',FisGetEnd(TRB->A1_END,TRB->A1_EST)[1])	
	cString += PedTag('numero',FisGetEnd(TRB->A1_END,TRB->A1_EST)[3])
	cString += PedTag('complemento',FisGetEnd(TRB->A1_END,TRB->A1_EST)[4])			
	cString += '</endereco>'	
	cString += PedTag('clientebloqueado',"0") // Padro 0 ou 1,
	cString += PedTag('descricaobloqueio',"")
	cString += PedTag('saldocredito',Transform(fTitVencido(TRB->A1_COD+TRB->A1_LOJA),"@E 999,999.99"))

	//------------------------------------------------------------//
	//Funo para verificar o motivo de bloqueio de documentao  //
	//------------------------------------------------------------//
    cMotivo := fVerLiCert()

	cString += PedTag('motivobloqueio',cMotivo)                      
	cString += PedTag('DocumentacaoOK',If(Empty(cMotivo),"1","0"))
	cString += '</cliente>'
	Fwrite(n_outfile, cString + chr(10), Len(cString) + 1)		

	dbSelectArea("TRB")
	dbSkip()
	cString := ""

EndDo
cString += '</clientes>'

dbSelectArea("TRB")
dbCloseArea()

//-----------------------------------//
//Funo para gravar XML no arquivo  //
//-----------------------------------//
Fwrite(n_outfile, cString + chr(10), Len(cString) + 1)

//---------------------------------//
//Fecha o arquivo xml em aberto    //
//---------------------------------//
fClose(n_outfile)

//-----------------------------------------------------------//
//Tenta se conectar ao servidor ftp para subir os arquivos   //
//-----------------------------------------------------------//
If ! FTPCONNECT ( "189.36.12.132" , PORT_FTP ,"INTRM", "rm@entire123" )		
	conout( "Nao foi possivel se conectar ao FTP Entire!!" )		
	Return(.f.)
EndIf    

//------------------------------------------------//
//Muda FTP para Diretorio de retorno de arquivos  //
//------------------------------------------------//
If ! FTPDIRCHANGE ( "/cliente" )		
	conout( "Nao foi possivel modificar diretrio!!" )		
	Return(.f.)
EndIf 	

If ! FTPUPLOAD ( c_arquivo, Substr(c_arquivo,15) )		
	conout( "Nao foi possivel realizar o upload!!" )   		
	Return(.f.)   	
EndIf		

//--------------------------//
//Fecha conexo com o ftp   //
//--------------------------//
FTPDISCONNECT()

//----------------------------------//
//Apaga arquivo apos gravar no FTP  //
//----------------------------------//
Ferase(c_arquivo)

//------------------------------------//
//Gera arquivo de produtos            //
//------------------------------------//
c_arquivo := PATHEXP + "RM_Produto_" + dtos(ddatabase) + strtran(time(),":","") + ".xml"
n_outfile := Fcreate(c_arquivo,0)
cString   := cCabXml
cGrupo    := ""

cQuery := "SELECT B1_GRUPO,B1_COD,B1_CODBAR,B1_DESC,B1_UM,B1_PSICOTR"
cQuery += " FROM " + RetSQLName("SB1")
cQuery += " WHERE D_E_L_E_T_ <> '*' AND B1_MSBLQL <> '1' AND LEFT(B1_DESC,2) <> 'ZZ' AND B1_GRUPO IN ('0105','0106','0107','0108','0109')"
cQuery += " ORDER BY B1_GRUPO,B1_COD"

TcQuery cQuery New Alias "TRB"

cString += '<familias>'
dbSelectArea("TRB")
dbGoTop()
While !Eof()         

	If TRB->B1_GRUPO != cGrupo
		If !Empty(cGrupo)
			cString += '</familia>'		
		EndIf
		cString += '<familia>'
		cString += PedTag('divisao',If(TRB->B1_GRUPO $ "0105/0106/0107","EMS","GERMED","LEGRAND") )  
		cString += PedTag('unidadenegocio',If(TRB->B1_GRUPO $ "0107/0108","MARCAS","GENERICO") )
		cString += PedTag('nomefamilia',Alltrim(Posicione("SBM",1,xFilial("SBM") + TRB->B1_GRUPO,"BM_DESC")) )
	EndIf
	
	cString += '<produto>'
	cString += PedTag('produtocod',Alltrim(TRB->B1_COD) )
	cString += PedTag('produtocodean',Alltrim(TRB->B1_CODBAR) )
	cString += PedTag('produtonome',Alltrim(TRB->B1_DESC) )		
	cString += PedTag('produtodsc',Alltrim(TRB->B1_DESC) )			
	cString += PedTag('produtounimedida',TRB->B1_UM )			
	cString += PedTag('produtobloqueio',If(TRB->B1_PSICOTR=="S","1","0"))
	cString += '</produto>'

	cGrupo := TRB->B1_GRUPO 
	dbSelectArea("TRB")
	dbSkip()

EndDo
cString += '</familia>'
cString += '</familias>'

dbSelectArea("TRB")
dbCloseArea()

//-----------------------------------//
//Funo para gravar XML no arquivo  //
//-----------------------------------//
Fwrite(n_outfile, cString + chr(10), Len(cString) + 1)

//---------------------------------//
//Fecha o arquivo xml em aberto    //
//---------------------------------//
fClose(n_outfile)

//-----------------------------------------------------------//
//Tenta se conectar ao servidor ftp para subir os arquivos   //
//-----------------------------------------------------------//
If ! FTPCONNECT ( "189.36.12.132" , PORT_FTP ,"INTRM", "rm@entire123" )		
	conout( "Nao foi possivel se conectar ao FTP Entire!!" )		
	Return(.f.)
EndIf    

//------------------------------------------------//
//Muda FTP para Diretorio de retorno de arquivos  //
//------------------------------------------------//
If ! FTPDIRCHANGE ( "/produto" )		
	conout( "Nao foi possivel modificar diretrio!!" )		
	Return(.f.)
EndIf 	

If ! FTPUPLOAD ( c_arquivo, Substr(c_arquivo,15) )		
	conout( "Nao foi possivel realizar o upload!!" )   		
	Return(.f.)   	
EndIf		

//--------------------------//
//Fecha conexo com o ftp   //
//--------------------------//
FTPDISCONNECT()

//----------------------------------//
//Apaga arquivo apos gravar no FTP  //
//----------------------------------//
Ferase(c_arquivo)

//------------------------------------//
//Gera arquivo de Setores             //
//------------------------------------//
c_arquivo := PATHEXP + "RM_Setor_" + dtos(ddatabase) + strtran(time(),":","") + ".xml"
n_outfile := Fcreate(c_arquivo,0)
cString   := cCabXml
cMunic    := ""

cQuery := "SELECT A1_COD_MUN,A1_MUN"
cQuery += " FROM " + RetSQLName("SA1")
cQuery += " WHERE D_E_L_E_T_ <> '*' AND A1_MSBLQL <> '1' AND LEFT(A1_NOME,2) <> 'ZZ' AND A1_COD_MUN <> ' '"
cQuery += " GROUP BY A1_COD_MUN,A1_MUN"
cQuery += " ORDER BY A1_COD_MUN"
TcQuery cQuery New Alias "TRB"

cString += '<setores>'
dbSelectArea("TRB")
dbGoTop()
While !Eof()
	
	//-------------------------------------------------------------------------------------------//
	//Pode haver caso de codigo de municipio dobrado por causa do nome da cidade ento desprezo  //
	//-------------------------------------------------------------------------------------------//
	If TRB->A1_COD_MUN <> cMunic
		cString += '<setor>'
		cString += PedTag('setorcod' , TRB->A1_COD_MUN)
		cString += PedTag('setordsc' , TRB->A1_MUN)		
		cString += '</setor>'
	EndIf
	
	cMunic := TRB->A1_COD_MUN
	dbSelectArea("TRB")
	dbSkip()		

EndDo
cString += '</setores>'

dbSelectArea("TRB")
dbCloseArea()

//-----------------------------------//
//Funo para gravar XML no arquivo  //
//-----------------------------------//
Fwrite(n_outfile, cString + chr(10), Len(cString) + 1)

//---------------------------------//
//Fecha o arquivo xml em aberto    //
//---------------------------------//
fClose(n_outfile)

//-----------------------------------------------------------//
//Tenta se conectar ao servidor ftp para subir os arquivos   //
//-----------------------------------------------------------//
If ! FTPCONNECT ( "189.36.12.132" , PORT_FTP ,"INTRM", "rm@entire123" )		
	conout( "Nao foi possivel se conectar ao FTP Entire!!" )		
	Return(.f.)
EndIf    

//------------------------------------------------//
//Muda FTP para Diretorio de retorno de arquivos  //
//------------------------------------------------//
If ! FTPDIRCHANGE ( "/setor" )		
	conout( "Nao foi possivel modificar diretrio!!" )		
	Return(.f.)
EndIf 	

If ! FTPUPLOAD ( c_arquivo, Substr(c_arquivo,15) )		
	conout( "Nao foi possivel realizar o upload!!" )   		
	Return(.f.)   	
EndIf		

//--------------------------//
//Fecha conexo com o ftp   //
//--------------------------//
FTPDISCONNECT()

//----------------------------------//
//Apaga arquivo apos gravar no FTP  //
//----------------------------------//
Ferase(c_arquivo)

//------------------------------------//
//Gera arquivo de Tabela de Precos    //
//------------------------------------//
c_arquivo := PATHEXP + "RM_TabelaPreco_" + dtos(ddatabase) + strtran(time(),":","") + ".xml"
n_outfile := Fcreate(c_arquivo,0)
cString   := cCabXml

cQuery := "SELECT B1_COD,B1_PRV1,B1_RMPRCFA,B1_VLR_ICM"
cQuery += " FROM " + RetSQLName("SB1")
cQuery += " WHERE D_E_L_E_T_ <> '*' AND B1_MSBLQL <> '1' AND LEFT(B1_DESC,2) <> 'ZZ' AND B1_GRUPO IN ('0105','0106','0107','0108','0109')"
cQuery += " ORDER BY B1_COD"

TcQuery cQuery New Alias "TRB"

cString += '<tabelas>'
cString += '<tabelapreco>'
cString += PedTag('descricao',"UNICA" )
cString += PedTag('codtabelapreco',"001" )
cString += PedTag('estadosigla',"PR" )
cString += PedTag('icms',Transform(12,"@E 999.99") )
dbSelectArea("TRB")
dbGoTop()
While !Eof()         

	If TRB->B1_PRV1 > 0
		cString += '<precoproduto>'
		cString += PedTag('produtocod',Alltrim(TRB->B1_COD) )
		cString += PedTag('precofabrica',Transform(TRB->B1_RMPRCFA,"@E 99,999.99") )
		cString += PedTag('precoconsumidor',Transform(TRB->B1_PRV1,"@E 99,999.99") )
		cString += PedTag('icmspauta',Transform(TRB->B1_VLR_ICM,"@E 99,999.99") )
		cString += '</precoproduto>'
	EndIf
	
	dbSelectArea("TRB")
	dbSkip()

EndDo
cString += '</tabelapreco>'
cString += '</tabelas>'

dbSelectArea("TRB")
dbCloseArea()

//-----------------------------------//
//Funo para gravar XML no arquivo  //
//-----------------------------------//
Fwrite(n_outfile, cString + chr(10), Len(cString) + 1)

//---------------------------------//
//Fecha o arquivo xml em aberto    //
//---------------------------------//
fClose(n_outfile)

//-----------------------------------------------------------//
//Tenta se conectar ao servidor ftp para subir os arquivos   //
//-----------------------------------------------------------//
If ! FTPCONNECT ( "189.36.12.132" , PORT_FTP ,"INTRM", "rm@entire123" )		
	conout( "Nao foi possivel se conectar ao FTP Entire!!" )		
	Return(.f.)
EndIf    

//------------------------------------------------//
//Muda FTP para Diretorio de retorno de arquivos  //
//------------------------------------------------//
If ! FTPDIRCHANGE ( "/TabelaPreco" )		
	conout( "Nao foi possivel modificar diretrio!!" )		
	Return(.f.)
EndIf 	

If ! FTPUPLOAD ( c_arquivo, Substr(c_arquivo,15) )		
	conout( "Nao foi possivel realizar o upload!!" )   		
	Return(.f.)   	
EndIf		

//--------------------------//
//Fecha conexo com o ftp   //
//--------------------------//
FTPDISCONNECT()

//----------------------------------//
//Apaga arquivo apos gravar no FTP  //
//----------------------------------//
Ferase(c_arquivo)

Return


*****************************
Static Function PED01EST(lJOB)
*****************************
Local c_arquivo := PATHEXP + "RM_Estoque_" + dtos(ddatabase) + strtran(time(),":","") + ".xml"
Local n_outfile := Fcreate(c_arquivo,0)
Local cString   := cCabXml
Local cQuery

cQuery := "SELECT B1_COD,(B2_QATU - B2_RESERVA) SALDO
cQuery += " FROM " + RetSQLName("SB1") + " A," + RetSQLName("SB2") + " B" 
cQuery += " WHERE A.D_E_L_E_T_ <> '*' AND B1_MSBLQL <> '1' AND LEFT(B1_DESC,2) <> 'ZZ' AND B1_GRUPO IN ('0105','0106','0107','0108','0109')"
cQuery += " AND A.B1_COD = B.B2_COD AND A.B1_LOCPAD = B.B2_LOCAL AND B.D_E_L_E_T_ <> '*' "
cQuery += " ORDER BY B1_COD"

TcQuery cQuery New Alias "TRB"

cString += '<estoque>'
dbSelectArea("TRB")
dbGoTop()
While !Eof()         

	cString += '<estoqueproduto>'
	cString += PedTag('produtocod',Alltrim(TRB->B1_COD) )
	cString += PedTag('cnpjdistribuidora',Alltrim(SM0->M0_CGC) )
	cString += PedTag('situacao',If(TRB->SALDO>0,"1","0" ) )
	cString += '</estoqueproduto>'
	
	dbSelectArea("TRB")
	dbSkip()

EndDo
cString += '</estoque>'

dbSelectArea("TRB")
dbCloseArea()

//-----------------------------------//
//Funo para gravar XML no arquivo  //
//-----------------------------------//
Fwrite(n_outfile, cString + chr(10), Len(cString) + 1)

//---------------------------------//
//Fecha o arquivo xml em aberto    //
//---------------------------------//
fClose(n_outfile)

//-----------------------------------------------------------//
//Tenta se conectar ao servidor ftp para subir os arquivos   //
//-----------------------------------------------------------//
If ! FTPCONNECT ( "189.36.12.132" , PORT_FTP ,"INTRM", "rm@entire123" )		
	conout( "Nao foi possivel se conectar ao FTP Entire!!" )		
	Return(.f.)
EndIf    

//------------------------------------------------//
//Muda FTP para Diretorio de retorno de arquivos  //
//------------------------------------------------//
If ! FTPDIRCHANGE ( "/Estoque" )		
	conout( "Nao foi possivel modificar diretrio!!" )		
	Return(.f.)
EndIf 	

If ! FTPUPLOAD ( c_arquivo, Substr(c_arquivo,15) )		
	conout( "Nao foi possivel realizar o upload!!" )   		
	Return(.f.)   	
EndIf		

//--------------------------//
//Fecha conexo com o ftp   //
//--------------------------//
FTPDISCONNECT()

//----------------------------------//
//Apaga arquivo apos gravar no FTP  //
//----------------------------------//
Ferase(c_arquivo)

Return


**************************************
Static Function PedTag(cTag,cConteudo)
**************************************
Local cRetorno := ""

//If (!Empty(AllTrim(cConteudo)) .And. IsAlpha(AllTrim(cConteudo))) .Or. Val(AllTrim(cConteudo))<>0
	cRetorno := "<" + cTag + ">" + AllTrim(cConteudo) + "</" + cTag + ">"
//EndIf

Return(cRetorno)


****************************
Static Function fVerLiCert()
****************************
Local cRet := ""

If(TRB->A1_PSICOTR < dtos(DDATABASE))
	cRet := "Cliente com Certificado de licena Vencido"
	Return(cRet)
EndIf

If(TRB->A1_RMLISAN < dtos(DDATABASE))
	cRet := "Cliente com licena Sanitria Vencida"
	Return(cRet)
EndIf

Return(cRet)


*********************************
Static Function fTitVencido(cCli)
*********************************
Local cQuery := "" 
Local nValor := 0

//VIEW USADA PARA TITULO DO SFA
cQuery += "SELECT DTVENCIMENTO AS DTVENC, VALORABERTO AS VLABERTO FROM APL_TITULOS "
cQuery += "WHERE APL_CLIENTE_ID = '" + cCli + "' "
TCQUERY cQuery NEW ALIAS "TRB2"   

dbSelectArea("TRB2")
While !Eof()
	If( (TRB2->DTVENC < dtos(DDATABASE)) .And. TRB2->VLABERTO > 0 )
		nValor += TRB2->VLABERTO
	EndIf

    dbSelectArea("TRB2")
	dbSkip()
Enddo
dbCloseArea("TRB2")
Return(nValor)



****************************
User Function RMPED01A(lJOB)
****************************
Private cCabXML := '<?xml version="1.0" standalone="yes"?>'
lJOB := ( lJOB != Nil )        
                     
WFPREPENV("01","01","RMPED01")
	
CONOUT("Atualiza FTP Entire...")

//-------------------------------------//
//Gera arquivos para subir ftp Entire  //
//-------------------------------------//
PED01EXP(lJOB)
		
//-----------------------------------------------//
//Atualiza apenas o arquivo de saldo em estoque  //
//-----------------------------------------------//
PED01EST(lJOB)	 	 

Return()